// dynamic-floats.c
#include "dynamic-floats.h"

// Initialize my_array (pointer) to NULL.
static float* my_array=NULL;        
// Initialize number of elements and number of allocated elements to zero.
static int num_elements=0;   // current number of meaningful elements
static int num_allocated=0;  // total possible number of elements

// Show the current number of elements.
int getNumElements(void) {
  return num_elements;
}

// Show the float at the specified location.
float getFloat(int location) {
  return my_array[location];
}

/* Add the specified value x to the end of the my_array.  If needed,
 * increase the size of the my_array using realloc(). */
void addToArray(float x) {
  if (num_elements == num_allocated) { // need to increase size
    if (my_array == NULL) {  // Initialize my_array if first element.
      my_array = (float*)malloc(sizeof(float));
      num_allocated = 1;
    } else {              // Double size of my_array othewise.
      num_allocated *= 2;
      my_array = (float*)realloc(my_array, num_allocated * sizeof(float));
      if (my_array == NULL) { // realloc() failed.  Terminate.
	printf("Reallocation failed.  Terminating.\n");
	exit(-1);
      }
    }
  }
  my_array[num_elements] = x;
  num_elements++;
  return;
}
